﻿// <auto-generated />
using System;
using Data;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using NetTopologySuite.Geometries;

namespace Data.Migrations
{
    [DbContext(typeof(DataContext))]
    [Migration("20200128220554_UpdateNetworkStoredProcedureAdd")]
    partial class UpdateNetworkStoredProcedureAdd
    {
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "3.1.1")
                .HasAnnotation("Relational:MaxIdentifierLength", 128)
                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

            modelBuilder.Entity("Core.Entities.ContinentEntity", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:IdentityIncrement", 1)
                        .HasAnnotation("SqlServer:IdentitySeed", 1)
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("Code")
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("nvarchar(255)")
                        .HasMaxLength(255);

                    b.HasKey("Id");

                    b.HasIndex("Id")
                        .IsUnique();

                    b.ToTable("Continents");
                });

            modelBuilder.Entity("Core.Entities.CountryEntity", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:IdentityIncrement", 1)
                        .HasAnnotation("SqlServer:IdentitySeed", 1)
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("A2Code")
                        .IsRequired()
                        .HasColumnType("nvarchar(2)")
                        .HasMaxLength(2);

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("nvarchar(255)")
                        .HasMaxLength(255);

                    b.HasKey("Id");

                    b.HasIndex("Id")
                        .IsUnique();

                    b.ToTable("Countries");
                });

            modelBuilder.Entity("Core.Entities.FirstSubDivisionEntity", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:IdentityIncrement", 1)
                        .HasAnnotation("SqlServer:IdentitySeed", 1)
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("IsoCode")
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("nvarchar(255)")
                        .HasMaxLength(255);

                    b.HasKey("Id");

                    b.HasIndex("Id")
                        .IsUnique();

                    b.ToTable("FirstSubDivisions");
                });

            modelBuilder.Entity("Core.Entities.GeoNameEntity", b =>
                {
                    b.Property<long>("Id")
                        .HasColumnType("bigint");

                    b.Property<string>("CityName")
                        .HasColumnType("nvarchar(255)")
                        .HasMaxLength(255);

                    b.Property<int>("ContinentId")
                        .HasColumnType("int");

                    b.Property<int>("CountryId")
                        .HasColumnType("int");

                    b.Property<int?>("FirstSubDivisionId")
                        .HasColumnType("int");

                    b.Property<bool>("IsInEuropeanUnion")
                        .HasColumnType("bit");

                    b.Property<int?>("SecondSubDivisionId")
                        .HasColumnType("int");

                    b.Property<int>("TimeZoneId")
                        .HasColumnType("int");

                    b.HasKey("Id");

                    b.HasIndex("ContinentId");

                    b.HasIndex("CountryId");

                    b.HasIndex("FirstSubDivisionId");

                    b.HasIndex("Id");

                    b.HasIndex("SecondSubDivisionId");

                    b.HasIndex("TimeZoneId");

                    b.ToTable("GeoNames");
                });

            modelBuilder.Entity("Core.Entities.NetworkEntity", b =>
                {
                    b.Property<int>("MinIpAddress")
                        .HasColumnType("int");

                    b.Property<int>("MaxIpAddress")
                        .HasColumnType("int");

                    b.Property<int?>("AccuracyRadius")
                        .HasColumnType("int");

                    b.Property<long?>("GeoNameId")
                        .HasColumnType("bigint");

                    b.Property<Point>("Location")
                        .HasColumnType("geography");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnName("Network")
                        .HasColumnType("nvarchar(18)")
                        .HasMaxLength(18);

                    b.Property<int?>("RegisteredCountryId")
                        .HasColumnType("int");

                    b.Property<int?>("RepresentedCountryId")
                        .HasColumnType("int");

                    b.HasKey("MinIpAddress", "MaxIpAddress")
                        .HasAnnotation("SqlServer:Clustered", true);

                    b.HasIndex("GeoNameId");

                    b.HasIndex("RegisteredCountryId");

                    b.HasIndex("RepresentedCountryId");

                    b.ToTable("Networks");
                });

            modelBuilder.Entity("Core.Entities.SecondSubDivisionEntity", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:IdentityIncrement", 1)
                        .HasAnnotation("SqlServer:IdentitySeed", 1)
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("IsoCode")
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("nvarchar(255)")
                        .HasMaxLength(255);

                    b.HasKey("Id");

                    b.HasIndex("Id")
                        .IsUnique();

                    b.ToTable("SecondSubDivisions");
                });

            modelBuilder.Entity("Core.Entities.TimeZoneEntity", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:IdentityIncrement", 1)
                        .HasAnnotation("SqlServer:IdentitySeed", 1)
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<bool?>("Dst")
                        .HasColumnType("bit");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("nvarchar(255)")
                        .HasMaxLength(255);

                    b.Property<int?>("UtcOffset")
                        .HasColumnType("int");

                    b.HasKey("Id");

                    b.HasIndex("Id")
                        .IsUnique();

                    b.ToTable("TimeZones");
                });

            modelBuilder.Entity("Core.Entities.GeoNameEntity", b =>
                {
                    b.HasOne("Core.Entities.ContinentEntity", "Continent")
                        .WithMany("GeoNames")
                        .HasForeignKey("ContinentId")
                        .OnDelete(DeleteBehavior.Restrict)
                        .IsRequired();

                    b.HasOne("Core.Entities.CountryEntity", "Country")
                        .WithMany("GeoNames")
                        .HasForeignKey("CountryId")
                        .OnDelete(DeleteBehavior.Restrict)
                        .IsRequired();

                    b.HasOne("Core.Entities.FirstSubDivisionEntity", "FirstSubDivision")
                        .WithMany("GeoNames")
                        .HasForeignKey("FirstSubDivisionId")
                        .OnDelete(DeleteBehavior.Restrict);

                    b.HasOne("Core.Entities.SecondSubDivisionEntity", "SecondSubDivision")
                        .WithMany("GeoNames")
                        .HasForeignKey("SecondSubDivisionId")
                        .OnDelete(DeleteBehavior.Restrict);

                    b.HasOne("Core.Entities.TimeZoneEntity", "TimeZone")
                        .WithMany("GeoNames")
                        .HasForeignKey("TimeZoneId")
                        .OnDelete(DeleteBehavior.Restrict)
                        .IsRequired();
                });

            modelBuilder.Entity("Core.Entities.NetworkEntity", b =>
                {
                    b.HasOne("Core.Entities.GeoNameEntity", "GeoName")
                        .WithMany("Networks")
                        .HasForeignKey("GeoNameId")
                        .OnDelete(DeleteBehavior.Restrict);

                    b.HasOne("Core.Entities.CountryEntity", "RegisteredCountry")
                        .WithMany("NetworksRegistered")
                        .HasForeignKey("RegisteredCountryId")
                        .OnDelete(DeleteBehavior.Restrict);

                    b.HasOne("Core.Entities.CountryEntity", "RepresentedCountry")
                        .WithMany("NetworksRepresented")
                        .HasForeignKey("RepresentedCountryId")
                        .OnDelete(DeleteBehavior.Restrict);
                });
#pragma warning restore 612, 618
        }
    }
}
